Loading...
Searching...
No Matches
etl::histogram< TKey, TCount, Max_Size, Start_Index > Class Template Reference

Histogram with a compile time start index. More...

`#include <histogram.h>`

## Public Types

typedef TKey | key_type
typedef TCount | count_type
typedef TCount | value_type
Public Types inherited from etl::private_histogram::histogram_common< TCount, Max_Size >
typedef etl::array< TCount, Max_Size >::const_iterator | const_iterator
Public Types inherited from etl::unary_function< TKey, void >
typedef TKey | argument_type
typedef void | result_type

## Public Member Functions

| ETL_STATIC_ASSERT (etl::is_integral< TKey >::value, "Only integral keys allowed")
| ETL_STATIC_ASSERT (etl::is_integral< TCount >::value, "Only integral count allowed")
| histogram ()
| Constructor.
template<typename TIterator>
| histogram (TIterator first, TIterator last)
| Constructor.
| histogram (const histogram &other)
| Copy constructor.
histogram & | operator= (const histogram &rhs)
| Copy assignment.
void | add (key_type key)
| Add.
template<typename TIterator>
void | add (TIterator first, TIterator last)
| Add.
void | operator() (key_type key)
| operator ()
template<typename TIterator>
void | operator() (TIterator first, TIterator last)
| operator ()
value_type | operator[] (key_type key) const
| operator []
Public Member Functions inherited from etl::private_histogram::histogram_common< TCount, Max_Size >
| ETL_STATIC_ASSERT (etl::is_integral< TCount >::value, "Only integral count allowed")
const_iterator | begin () const
| Beginning of the histogram.
const_iterator | cbegin () const
| Beginning of the histogram.
const_iterator | end () const
| End of the histogram.
const_iterator | cend () const
| End of the histogram.
void | clear ()
| Clear the histogram.
ETL_CONSTEXPR size_t | size () const
| Size of the histogram.
ETL_CONSTEXPR size_t | max_size () const
| Max size of the histogram.
size_t | count () const
| Count of items in the histogram.

## Additional Inherited Members

Static Public Attributes inherited from etl::private_histogram::histogram_common< TCount, Max_Size >
static ETL_CONSTANT size_t | Max_Size
Protected Attributes inherited from etl::private_histogram::histogram_common< TCount, Max_Size >
etl::array< TCount, Max_Size > | accumulator

## Detailed Description

template<typename TKey, typename TCount, size_t Max_Size, int32_t Start_Index = etl::integral_limits<int32_t>::max>
class etl::histogram< TKey, TCount, Max_Size, Start_Index >

Histogram with a compile time start index.

The documentation for this class was generated from the following file:

- include/etl/histogram.h